/**
 * Grillino - an Annoy-a-tron clone
 * Copyright (C) 2014 Cristiano Griletti (Mastro Gippo)
 * http://www.mastrogippo.it/2014/05/making-stuff-in-shenzhen-the-grillino/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
// Cricket generator: http://www.willowdesign.info/blog/digistump-cricket-generator/
// Narcoleptic library: https://code.google.com/p/narcoleptic/

#include <Narcoleptic.h>

int Pin1 = 3;
int Pin2 = 4;

void setup(){
  pinMode(Pin1, OUTPUT); 
  pinMode(Pin2, OUTPUT); 
  randomSeed(analogRead(0));
  analogReference(INTERNAL);
}

int x,y,z;
void chirp()
{
  byte a,b,w,x,z;
  w=random(20-22);
  z=random(195,197);
  for (b=5;b;b--)
  {
    x=1; y=z+(random(1,2));
    for (a=0; a<125;++a)
    {
      //adapted to sound better on ATTiny
      digitalWrite(Pin1, HIGH); digitalWrite(Pin2, LOW);
      digitalWrite(Pin1, LOW); digitalWrite(Pin2, HIGH);
      digitalWrite(Pin2, LOW);
      x++; y--;
      if (x==100) y-=50;
    }
    delay(w);
  }
}

void loop()
{

  int hr;
  
  chirp();
  Narcoleptic.delay(100);
  chirp();
  Narcoleptic.delay(1000);
  chirp();
  Narcoleptic.delay(100);
  chirp();    
  Narcoleptic.delay(1000);
  chirp();
  Narcoleptic.delay(100);
  chirp();    
  ADCSRA &= ~(1<<ADEN); //Disable ADC, saves ~230uA

  //I could save some uA by directly calling sleep functions, but meh...
  for(hr = 0; hr < 450; hr++) //1hour
    Narcoleptic.delay(8000);
    
  for(hr = random(1, 450); hr > 1; hr--) //random wait 0-1hour
    Narcoleptic.delay(8000);
}
    

